// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  public class ch11ex6 extends Example {
    private const MXML:XML =
      <s:Application
         xmlns:fx="http://ns.adobe.com/mxml/2009"
         xmlns:s="library://ns.adobe.com/flex/spark"
         xmlns:mx="library://ns.adobe.com/flex/halo">
         <s:Button label="Test" id="myButton"/>
         <mx:Slider direction="horizontal" id="mySlider"/>
         <fx:Script><![CDATA[
             protected const AUTHOR:String = "roger";
         ]]></fx:Script>
      </s:Application>
      
    public function ch11ex6() {
      var s:Namespace = new Namespace("library://ns.adobe.com/flex/spark");
      default xml namespace = s;
      
      var newXML:XML = <Application><Button label="new button"/></Application>;
      trace(newXML.toXMLString());
      //<Application xmlns="library://ns.adobe.com/flex/spark"...
      //any new XML you create uses this as the default namespace
      
      trace(MXML.Button.toXMLString());
      //the s namespace is open as the default namespace so no need to scope this
      
      MXML.appendChild(<VGroup/>);
      MXML.VGroup.appendChild(<CheckBox label="new control!"/>);
      trace(MXML.toXMLString());
      //these new nodes get assigned to the s namespace too.
      //...<s:VGroup>
      //     <s:CheckBox label="new control!"/>
      //   </s:VGroup>
    } 
  }
}
