// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.CapsStyle;
  import flash.display.Sprite;
  import flash.events.MouseEvent;
  
  public class ch14ex3 extends Sprite {
    protected const NUM_SEGMENTS:int = 10;
    protected var segmentRotation:Number = 0;
    protected var allSegments:Array;
    public function ch14ex3() {
      allSegments = new Array();
      var segmentLength:Number = stage.stageWidth / NUM_SEGMENTS;
      var segment:Sprite = this;
      segment.y = stage.stageHeight/2;
      for (var i:int = 0; i < NUM_SEGMENTS; i++) {
        var childSegment:Sprite = makeSegment(segmentLength);
        segment.addChild(childSegment);
        childSegment.x = segmentLength;
        allSegments.push(childSegment);
        //every segment gets added as a child of the last one
        segment = childSegment;
      }
      stage.addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
    }
    protected function onMouseMove(event:MouseEvent):void {
      var segmentRotation:Number =
        360/NUM_SEGMENTS * 2*((stage.mouseY / stage.stageHeight) - 0.5);
      for each (var segment:Sprite in allSegments) {
        //all rotation values are set to the same number,
        //yet the line curls inward progressively!
        //this is because every rotation affects all its children.
        segment.rotation = segmentRotation;
      }
    }
    protected function makeSegment(length:Number):Sprite {
      var s:Sprite = new Sprite();
      s.graphics.lineStyle(16, 0x4F7302, 1, false, null, CapsStyle.NONE);
      s.graphics.lineTo(length, 0);
      return s;
    }
  }
}