// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.events.TextEvent;
  import flash.text.*;

  public class ch17ex10 extends Sprite {
    protected var tf:TextField;
    public function ch17ex10() {
      tf = new TextField();
      tf.selectable = false;
      tf.defaultTextFormat = new TextFormat("_sans", 14);
      tf.multiline = tf.wordWrap = true;
      tf.width = 200;
      tf.htmlText = "This text controls itself. You could turn it" + 
' <a href="event:color,0xff0000"><u>red</u></a> or' + 
' <a href="event:color,0x00ff00"><u>green</u></a>. Or you could' + 
' <a href="event:move,20,0"><u>move it right</u></a> or' + 
' <a href="event:move,0,20"><u>move it down</u></a>.';
      tf.addEventListener(TextEvent.LINK, onLink);
      addChild(tf);
    }
    
    protected function onLink(event:TextEvent):void {
      var args:Array = event.text.split(",");
      if (args.length < 1) return;
      switch (args.shift()) {
        case "color": colorText.apply(this, args); break;
        case "move": moveText.apply(this, args); break;
      }
    }
    
    protected function colorText(colorStr:String):void {
      tf.setTextFormat(new TextFormat(null, null, parseInt(colorStr, 16)));
    }
    
    protected function moveText(xStr:String, yStr:String):void {
      tf.x += parseFloat(xStr);
      tf.y += parseFloat(yStr);
    }
  }
}