// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.text.TextField;
  import flash.text.TextFieldAutoSize;
  import flash.text.TextFormat;
  
  public class ch17ex2 extends Sprite {
    protected const TEXT:String =  "Gaius Marius (157 BCE-January 13, 86 BCE)\
 was a Roman general and politician";
    
    public function ch17ex2() {
      //A - manually sized, small
      var smalltf:TextField = new TextField();
      smalltf.border = true; //we'll turn on the border to see the size
      smalltf.width = 100;
      smalltf.height = 30;
      smalltf.text = TEXT;
      smalltf.y = 0; //appears on top
      addChild(smalltf); //not all text will fit
      
      //B - manually sized, big
      var bigtf:TextField = new TextField();
      bigtf.border = true;
      bigtf.width = 800;
      bigtf.height = 30;
      bigtf.text = TEXT;
      bigtf.y = 50; //appears in the middle
      addChild(bigtf); //all the text fits, with extra space
      
      //C - autosizing
      var autotf:TextField = new TextField();
      autotf.border = true;
      autotf.width = autotf.height = 0; //let autosize grow the size from 0
      autotf.autoSize = TextFieldAutoSize.LEFT;
      autotf.text = TEXT;
      autotf.y = 100; //appears on bottom
      addChild(autotf); //all text fits perfectly
    }
  }
}