// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.text.engine.*;
  
  public class ch18ex1 extends Sprite {
    private const LEADING:Number = 4;
    private const FONT_SIZE:Number = 14;
    private const FONT_COLOR:Number = 0x303070;
    public function ch18ex1() {
      //create the content and formatting models, and associate them.
      var content:TextElement = new TextElement("Lorem ipsum dolor sit amet, \
consectetur adipiscing elit. Nulla massa magna, lobortis non viverra a, \
hendrerit ut est. Nullam eget mauris ac nisl iaculis scelerisque. \
In sodales orci posuere sem gravida luctus.\n\n\
      Did I mention Hello World in there?");
      var fontDescription:FontDescription = new FontDescription("_typewriter");
      content.elementFormat = 
        new ElementFormat(fontDescription, FONT_SIZE, FONT_COLOR);
      
      //create the controller, and give it the model.
      var block:TextBlock = new TextBlock();
      block.content = content;
      
      //use the controller to generate views, add them to stage.
      var line:TextLine = null;
      var textY:Number = 0;
      while (line = block.createTextLine(line, stage.stageWidth)) {
        textY += line.textHeight + LEADING;
        line.y = textY;
        addChild(line);
      }
    }
  }
}
