// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.geom.Rectangle;
  import flash.text.engine.LigatureLevel;
  import flashx.textLayout.elements.*;
  import flashx.textLayout.factory.TextFlowTextLineFactory;
  import flashx.textLayout.formats.TextLayoutFormat;
  
  public class ch18ex2 extends Sprite {
    public function ch18ex2() {
      //create the content models TextFlow > Paragraph > Span > text
      var content:TextFlow = new TextFlow();
      var p:ParagraphElement = new ParagraphElement();
      var span:SpanElement = new SpanElement();
      content.addChild(p);
      p.addChild(span);
      
      span.text = "Some say the world will end in fire,\n\
Some say in ice.\n\
From what I've tasted of desire\n\
I hold with those who favour fire.\n\
But if it had to perish twice,\n\
I think I know enough of hate\n\
To say that for destruction ice\n\
Is also great\n\
And would suffice.\n\n\
\u2014Robert Frost"; //unicode for em dash used in this line.
      
      //create the format model. use ligatures and leading
      var format:TextLayoutFormat = new TextLayoutFormat();
      format.fontFamily = "Caslon, Garamond, _serif";
      format.ligatureLevel = LigatureLevel.COMMON;
      format.fontSize = 17;
      format.lineHeight = 28;
      format.color = 0x303030;
      content.format = format;

      //create a factory, set its bounds, and let it generate lines
      var controller:TextFlowTextLineFactory = new TextFlowTextLineFactory();
      var fullW:Number = stage.stageWidth;
      var fullH:Number = stage.stageHeight;
      controller.compositionBounds = new Rectangle(fullW/4, 20, fullW/2, fullH);
      controller.createTextLines(onLineCreated, content);
    }
    //called by the TextFlowTextLineFactory every time a line is created
    private function onLineCreated(line:DisplayObject):void {
      //it's still our job to add these to the display list
      addChild(line);
    }
  }
}