// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  
  import flash.geom.Rectangle;
  import flash.text.*;
  
  import flashx.textLayout.conversion.ConversionType;
  import flashx.textLayout.conversion.TextConverter;
  import flashx.textLayout.elements.TextFlow;
  import flashx.textLayout.factory.TextFlowTextLineFactory;

  public class ch18ex5 extends Example {
    public function ch18ex5() {
      //import TLF markup
      XML.ignoreWhitespace = false;
      var tlfxml:XML =
<TextFlow xmlns="http://ns.adobe.com/textLayout/2008">
<format name="red" id="red" color="0xff0000"/>
<p fontFamily="Calibri, Verdana, _sans" fontSize="28">Mind your
<span format="red">p</span>s and <span format="red">q</span>s!</p>
</TextFlow>;
      var textFlow:TextFlow =
        TextConverter.importToFlow(tlfxml, TextConverter.TEXT_LAYOUT_FORMAT);

      //display TextFlow
      var factory:TextFlowTextLineFactory = new TextFlowTextLineFactory();
      factory.compositionBounds = new Rectangle(0, 0, 500, 500);
      factory.createTextLines(this.addChild, textFlow);
      
      //export as TextField markup
      var tfhtml:String = TextConverter.export(textFlow,
        TextConverter.HTML_FORMAT, ConversionType.STRING_TYPE) as String;
      trace("\n\n\n\n\n\n\n" + tfhtml);
      
      //display TextField
      var tf:TextField = new TextField();
      tf.y = 50;
      tf.autoSize = TextFieldAutoSize.LEFT;
      addChild(tf);
      tf.htmlText = tfhtml;
    }
  }
}