// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.events.MouseEvent;
  import flash.text.*;
  
  import flashx.textLayout.compose.StandardFlowComposer;
  import flashx.textLayout.container.ContainerController;
  import flashx.textLayout.conversion.TextConverter;
  import flashx.textLayout.edit.TextClipboard;
  import flashx.textLayout.edit.TextScrap;
  import flashx.textLayout.elements.*;
  public class ch18ex7 extends Sprite {
    protected var flow:TextFlow;
    public function ch18ex7() {
      flow = TextConverter.importToFlow("Cellar door",
        TextConverter.PLAIN_TEXT_FORMAT);
      flow.fontFamily = "_typewriter";
      flow.fontSize = 11;
      flow.flowComposer = new StandardFlowComposer();
      
      var container:Sprite = new Sprite();
      addChild(container); container.x = 10; container.y = 10;
      var containerController:ContainerController = 
        new ContainerController(container, 300, 20);
      flow.flowComposer.addController(containerController);
      flow.flowComposer.updateAllControllers();
      
      var button:TestButton = new TestButton(100, 20, "Copy");
      button.addEventListener(MouseEvent.CLICK, onClick);
      addChild(button); button.x = 320; button.y = 10;
      
      //textfield to try pasting to afterwards
      var tf:TextField = new TextField();
      tf.type = TextFieldType.INPUT;
      tf.defaultTextFormat = new TextFormat("_typewriter", 11);
      tf.width = 410; tf.height = 100;
      tf.border = true;
      tf.wordWrap = tf.multiline = true;
      tf.text = "Try pasting the result here.";
      addChild(tf); tf.x = 10; tf.y = 40;
    }
    protected function onClick(event:MouseEvent):void {
      TextClipboard.setContents(
        TextScrap.createTextScrap(new TextRange(flow, 0, flow.textLength)));
    }
  }
}
import flash.display.*;
import flash.text.*;
class TestButton extends Sprite {
  public var label:TextField;
  public function TestButton(w:Number, h:Number, labelText:String) {
    graphics.lineStyle(0.5, 0, 0, true); graphics.beginFill(0xa0a0a0);
    graphics.drawRoundRect(0, 0, w, h, 8);
    label = new TextField(); addChild(label);
    label.defaultTextFormat = new TextFormat("_sans", 11, 0, true, false,
      false, null, null, "center");
    label.width = w; label.height = h; label.text = labelText;
    label.y = (h - label.textHeight)/2 - 2;
    buttonMode = true; mouseChildren = false;
  }
}