// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.accessibility.AccessibilityProperties;
  import flash.display.Sprite;
  import flash.events.KeyboardEvent;
  import flash.events.MouseEvent;
  import flash.text.*;
  import flash.ui.Keyboard;

  public class ch21ex12 extends Sprite {
    protected var input:TextField;
    protected var submitButton:TestButton;
    protected var clearButton:TestButton;
    public function ch21ex12() {
      input = new TextField();
      input.type = TextFieldType.INPUT;
      input.defaultTextFormat = new TextFormat("_sans", 12, 0);
      input.width = 215; input.height = 20;
      input.border = true;
      addChild(input);
      input.x = 10; input.y = 10;
      input.addEventListener(KeyboardEvent.KEY_UP, onInputKey);
      
      submitButton = new TestButton(100, 30, "Submit");
      addChild(submitButton);
      submitButton.x = 10; submitButton.y = 40;
      submitButton.addEventListener(MouseEvent.CLICK, onSubmit);
      
      clearButton = new TestButton(100, 30, "Clear");
      addChild(clearButton);
      clearButton.x = 125; clearButton.y = 40;
      clearButton.addEventListener(MouseEvent.CLICK, onClear);

      stage.focus = input;
    }
    protected function onInputKey(event:KeyboardEvent):void {
      if (event.keyCode == Keyboard.ENTER) {
        onSubmit(null);
      }
    }
    protected function onSubmit(event:MouseEvent):void {
      stage.focus = null;
      submitButton.label.text = "Submitted!";
      input.mouseEnabled = input.tabEnabled = false;
      input.background = true;
      input.backgroundColor = 0xb0b0b0;
      clearButton.removeEventListener(MouseEvent.CLICK, onClear);
    }
    protected function onClear(event:MouseEvent):void {
      input.text = "";
      stage.focus = input;
    }
  }
}
import flash.display.*;
import flash.text.*;
class TestButton extends Sprite {
  public var label:TextField;
  public function TestButton(w:Number, h:Number, labelText:String) {
    graphics.lineStyle(0.5, 0, 0, true);
    graphics.beginFill(0xa0a0a0);
    graphics.drawRoundRect(0, 0, w, h, 8);
    label = new TextField();
    addChild(label);
    label.defaultTextFormat = new TextFormat("_sans", 11, 0, true, false,
      false, null, null, "center");
    label.width = w;
    label.height = h;
    label.text = labelText;
    label.y = (h - label.textHeight)/2 - 2;
    buttonMode = true;
    mouseChildren = false;
  }
}