// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.*;
  import flash.geom.Point;
  import flash.ui.*;
  [SWF(backgroundColor="0")]
  public class ch21ex13 extends Sprite {
    public function ch21ex13() {
      var circ:DraggableCircle = new DraggableCircle();
      circ.x = circ.y = 100;
      addChild(circ);
      
      var menu:ContextMenu = new ContextMenu();
      menu.hideBuiltInItems();
      var item:ContextMenuItem;
      item = new ContextMenuItem("Arrange all");
      item.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, onArrange);
      menu.customItems.push(item);
      contextMenu = menu;
    }
    protected function onArrange(event:ContextMenuEvent):void {
      for (var i:int = 0, x:Number = 50, y:Number = 50; i < numChildren; i++) {
        var circ:DisplayObject = getChildAt(i);
        circ.x = x; circ.y = y;
        if ((x += 50) > stage.stageWidth) {x = 0; y += 50;}
      }
    }
  }
}
import flash.display.*;
import flash.events.*;
import flash.ui.*;
class DraggableCircle extends Sprite {
  public function DraggableCircle() {
    graphics.beginFill(makeColor(), 0.5);
    graphics.drawCircle(0, 0, 50);
    graphics.endFill();
    addEventListener(MouseEvent.MOUSE_DOWN, onStartDrag);
    buttonMode = true;
    blendMode = BlendMode.ADD;
    
    var menu:ContextMenu = new ContextMenu();
    menu.hideBuiltInItems();
    var item:ContextMenuItem = new ContextMenuItem("Clone");
    item.addEventListener(ContextMenuEvent.MENU_ITEM_SELECT, onClone);
    menu.customItems.push(item);
    contextMenu = menu;
  }
  protected function makeColor():uint {
    var rnd:Function = function():uint{return uint(Math.random() * 256)};
    return (rnd() << 16 | rnd() << 8 | rnd());
  }
  protected function onStartDrag(event:MouseEvent):void {
    startDrag();
    stage.addEventListener(MouseEvent.MOUSE_UP, onStopDrag);
  }
  protected function onStopDrag(event:MouseEvent):void {
    stage.removeEventListener(MouseEvent.MOUSE_UP, onStopDrag);
    stopDrag();
  }
  public function onClone(event:ContextMenuEvent):void {
    var copy:DraggableCircle = new DraggableCircle();
    copy.x = this.x + 10;
    copy.y = this.y + 10;
    this.parent.addChild(copy);
  }
}