// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  import flash.text.*;

  public class ch22ex5 extends Example {
    protected const redirectURL:String = "http://www.wonderfl.net";
    protected const redirectDelay:Number = 5 * 1000;
    public function ch22ex5() {
      var redirect:Redirect = new Redirect(redirectURL, redirectDelay);
       
      trace("This page no longer exists. You will be redirected to\n"
            + redirectURL + " after " + redirectDelay/1000 + " seconds.");
    }
  }
}

import flash.utils.Timer;
import flash.events.*;
import flash.net.*;
class Redirect {
  private var redirectTimer:Timer;
  private var redirectURL:URLRequest;
  private static const REDIRECT_DELAY:int = 5000;
  
  public function Redirect(url:String, delay:Number=REDIRECT_DELAY) {
    redirectURL = new URLRequest(url);
    redirectTimer = new Timer(delay, 1);
    redirectTimer.addEventListener(TimerEvent.TIMER,onRedirect);
    redirectTimer.start();
  }
  
  private function onRedirect(event:Event):void {
    navigateToURL(redirectURL, "_self");
  }
}