// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  import flash.system.Capabilities;
  import flash.ui.Multitouch;
  import flash.ui.MultitouchInputMode;
  public class ch23ex1 extends Example {
    protected var isMultitouch:Boolean;
    public function ch23ex1() {
      try {
        var test:Class = Multitouch; //older FP should throw error here
        trace("Multitouch capabilities on this device:");
        trace("Screen type:", Capabilities.touchscreenType);
        trace("Touch-level access?", Multitouch.supportsTouchEvents);
        trace("Gesture-level access?", Multitouch.supportsGestureEvents);
        trace("Number of touch points:", Multitouch.maxTouchPoints);
        if (Multitouch.supportsGestureEvents) {
          trace("supported gestures {");
          for each (var gestureName:String in Multitouch.supportedGestures) {
            trace("  -", gestureName);
          }
          trace("}");
        }
        //remember whether multitouch mode is on
        isMultitouch = Multitouch.maxTouchPoints > 1;
        //prefer gesture mode if available
        if (Multitouch.supportsGestureEvents) {
          Multitouch.inputMode = MultitouchInputMode.GESTURE;
        } else if (Multitouch.supportsTouchEvents) {
          Multitouch.inputMode = MultitouchInputMode.TOUCH_POINT;
        }
      } catch (error:ReferenceError) {
        trace("Sorry, but multitouch is not supported in this runtime.");
        isMultitouch = false;
      }
    }
  }
}