// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.*;
  import flash.net.URLRequest;
  import flash.system.LoaderContext;
  import flash.text.*;

  public class ch27ex3 extends Sprite {
    protected var bmpData:BitmapData;
    protected var swatch:Swatch;
  
    public function ch27ex3() {
      var l:Loader = new Loader();
      //photo   (CC-BY) Roger Braunstein
      //source  http://www.flickr.com/photos/rogerimp/188712483/
      var url:String = "http://actionscriptbible.com/files/pastels.jpg";
      l.load(new URLRequest(url), new LoaderContext(true));
      l.contentLoaderInfo.addEventListener(Event.COMPLETE, onComplete);
      l.contentLoaderInfo.addEventListener(IOErrorEvent.IO_ERROR, onError);
      addChild(l);
    }
    
    protected function onComplete(event:Event):void {
      var loader:Loader = LoaderInfo(event.target).loader;
      if (loader.content is Bitmap) {
        bmpData = Bitmap(loader.content).bitmapData;
        swatch = new Swatch();
        addChild(swatch);
        addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
      }
    }

    protected function onError(event:ErrorEvent):void {
      trace(event.text);
    }
    
    protected function onMouseMove(event:MouseEvent):void {
      var mx:int = stage.mouseX, my:int = stage.mouseY;
      if (mx >= 0 && mx < bmpData.width && my >= 0 && my < bmpData.height) {
        swatch.x = mx;
        swatch.y = my;
        swatch.color = bmpData.getPixel(mx, my);
        event.updateAfterEvent();
      }
    }
  }
}

import flash.display.Shape;
class Swatch extends Shape {
  public function set color(c:uint):void {
    graphics.beginFill(c);
    graphics.lineStyle(0, 0xffffff, 1, true);
    graphics.drawRect(10, 10, 25, 15);
    graphics.endFill();
  }
}