// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.Event;
  import flash.net.URLRequest;
  import flash.system.*;
  import flash.text.*;
  import flash.utils.describeType;
  
  public class ch27ex4 extends Sprite {
    public function ch27ex4() {
      var l:Loader;
      l = new Loader();
      l.load(new URLRequest("http://actionscriptbible.com/files/icon-fl.swf"),
        new LoaderContext(true, null, SecurityDomain.currentDomain));
      l.contentLoaderInfo.addEventListener(Event.COMPLETE, onComplete);
      
      l = new Loader();
      l.load(new URLRequest("http://actionscriptbible.com/files/icon-fx.swf"),
        new LoaderContext(true, null, SecurityDomain.currentDomain));
      l.contentLoaderInfo.addEventListener(Event.COMPLETE, onComplete);
    }
    
    protected function onComplete(event:Event):void {
      var loaderInfo:LoaderInfo = LoaderInfo(event.target);
      var iconClass:Class = 
        Class(loaderInfo.applicationDomain.getDefinition("assets.Icon"));
      var icon:DisplayObject = DisplayObject(new iconClass());
      addChild(icon);
      
      var tf:TextField = new TextField();
      tf.defaultTextFormat = new TextFormat("_sans", 11, 0);
      tf.width = 150; tf.height = 400; tf.y = 130;
      tf.multiline = tf.wordWrap = true;
      addChild(tf);
      
      tf.text = loaderInfo.url + "\n\n" + typeInfo(icon);
      if (numChildren > 2) tf.x = icon.x = 160;
    }
    
    protected function typeInfo(obj:Object):String {
      var info:XML = describeType(obj);
      var ret:String = info.@name;
      for each (var extendsNode:XML in info.extendsClass) {
        ret += " \u2192 " + extendsNode.@type.toString().replace(/^.*::/, "");
      }
      return ret;
    }
  }
}