// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  import flash.events.*;
  import flash.net.*;
  public class ch28ex1 extends Example {
    private const ENDPOINT:String = "http://geocoder.us/service/rest/geocode";
    public function ch28ex1() {
      geocode("2225 Jackson Ave, Long Island City, NY");
    }
    public function geocode(address:String):void {
      trace("Looking up " + address + "...");
      var req:URLRequest = new URLRequest();
      req.url = ENDPOINT;
      req.method = URLRequestMethod.GET;
      req.data = "address=" + address;
      var loader:URLLoader = new URLLoader(req);
      loader.addEventListener(Event.COMPLETE, onLoadComplete);
      loader.addEventListener(IOErrorEvent.IO_ERROR, onError);
    }
    protected function onLoadComplete(event:Event):void {
      var loader:URLLoader = URLLoader(event.target);
      var response:XML = XML(loader.data);
      var geo:Namespace = response.namespace("geo");
      var lat:Number = parseFloat(response..geo::lat.text());
      var long:Number = parseFloat(response..geo::long.text());
      trace("(" + lat + ", " + long + ")");
    }
    protected function onError(event:Event):void {
      trace("Error!");
    }
  }
}