// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import be.wellconsidered.services.Operation;
  import be.wellconsidered.services.WebService;
  import be.wellconsidered.services.events.OperationEvent;
  import com.actionscriptbible.Example;
  public class ch28ex2 extends Example {
    protected var weatherService:WebService;
    public function ch28ex2() {
      weatherService = new WebService(
        "http://www.webservicex.net/WeatherForecast.asmx?wsdl");
      getWeatherByZipCode("11238");
    }
    public function getWeatherByZipCode(zipCode:String):void {
      trace("Looking up weather in " + zipCode + "...");
      var op:Operation = new Operation(weatherService);
      op.addEventListener(OperationEvent.COMPLETE, onResult);
      op.addEventListener(OperationEvent.FAILED, onFault);
      op.GetWeatherByZipCode(zipCode);
    }
    protected function onResult(e:OperationEvent):void {
      var result:Object = e.data;
      trace("Weather for " + result.PlaceName + ", " + result.StateCode);
      for each (var weatherToday:Object in result.Details) {
        trace(weatherToday.Day + ":\t" +
              "Low " + weatherToday.MinTemperatureF + 
              "\tHigh " + weatherToday.MaxTemperatureF);
      }
    }
    protected function onFault(e:OperationEvent):void { 
      trace("Error: " + e.data);
    }
  }
}