// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  import flash.events.Event;
  import flash.events.ProgressEvent;
  import flash.net.Socket;
  public class ch28ex3 extends Example {
    protected var sock:Socket;
    public function ch28ex3():void {
      sock = new Socket("actionscriptbible.com", 80); //http uses port 80
      sock.addEventListener(Event.CONNECT, onConnected);
      sock.addEventListener(Event.CLOSE, onClosed);
      sock.addEventListener(ProgressEvent.SOCKET_DATA, onSocketData);
    }
    protected function onConnected(event:Event):void {
      //make a request
      var request:String = "GET /files/hand.xml HTTP/1.1\n" +
                           "Host: www.actionscriptbible.com\n\n";
      sock.writeUTFBytes(request);
    }
    protected function onSocketData(event:ProgressEvent):void {
      //we got some data... let's just let it fill up the buffer
      //and wait for the server to disconnect!
    }
    protected function onClosed(event:Event):void {
      var response:String = sock.readUTFBytes(sock.bytesAvailable);
      trace(response);
    }
  }
}