// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  import flash.net.SharedObject;
  public class ch29ex1 extends Example {
    public function ch29ex1() {
      //retrieve or create a SharedObject
      var hiscores:SharedObject = SharedObject.getLocal("/hiscores");

      //initialize properties if they don't exist
      if (!hiscores.data.highest) hiscores.data.highest = 999999;
      if (!hiscores.data.scores) hiscores.data.scores = new Array();
      
      //add a new entry
      hiscores.data.scores.push(
        {score: int(Math.random()*1000), time: (new Date()).time}
      ); 
      
      //dump all the data
      trace("HIGHEST SCORE: " + hiscores.data.highest);
      for (var i:int = 0; i < hiscores.data.scores.length; i++) {
        trace("Score:\t" + hiscores.data.scores[i].score +
              "\tat\t" + new Date(hiscores.data.scores[i].time).toString());
      }
    }
  }
}