// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  
  import flash.net.SharedObject;
  import flash.net.registerClassAlias;

  public class ch29ex4 extends Example {
    protected static const RED:uint = 0xff0000;
    protected var currentPage:int;
    protected var so:SharedObject;
    
    public function ch29ex4() {
      registerClassAlias("Bookmark", Bookmark);
      so = SharedObject.getLocal("storage");
      if (so.data.bookmark) {
        trace("Found bookmark...");
        trace(so.data.bookmark);
      } else {
        so.data.bookmark = new Bookmark(345, RED, "b");
        trace("Saving bookmark...");
      }
    }
  }
}

import flash.utils.IDataOutput;
import flash.utils.IDataInput;
import flash.utils.IExternalizable;
class Bookmark implements IExternalizable {
  protected var page:int;
  protected var color:uint;
  protected var name:String;
  
  public function Bookmark(page:int = 0, color:uint = 0, name:String = null) {
      this.page = page;
      this.color = color;
      this.name = name;
  }
  
  public function getPage():int {
    return this.page;
  }
  
  public function readExternal(input:IDataInput):void {
    var props:Object = input.readObject();
    page = props.page;
    color = props.color;
    name = props.name;
  }
  
  public function writeExternal(output:IDataOutput):void {
    var props:Object = {page: page, color: color, name: name};
    output.writeObject(props);
  }
  
  public function toString():String {
    return "[Bookmark at page " + page + " color: 0x" + color.toString(16) +
           " name: " + name + "]";
  }
}
