// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  
  import flash.events.*;
  import flash.net.*;
  public class ch30ex1 extends Example {
    public function ch30ex1() {
      var fileReference:FileReference = new FileReference();
      fileReference.addEventListener(Event.SELECT, onSelect);
      fileReference.addEventListener(Event.CANCEL, onCancel);
      
      var btn:TestButton = new TestButton(100, 25, "Browse");
      addChild(btn);
      btn.x = btn.y = 20;
      btn.addEventListener(MouseEvent.CLICK, function(event:MouseEvent):void {
        fileReference.browse([
          new FileFilter("All Files", "*"),
          new FileFilter("Images", "*.png;*.jpg")
        ]);
      });
      trace("\n\n\n");
    }
    private function onSelect(event:Event):void {
      var fileReference:FileReference = FileReference(event.target);
      var extension:String = fileReference.name.match(/\.\w+$/)[0];
      trace("So you like " + extension + "s, huh?");
    }
    private function onCancel(event:Event):void {
      trace("What, you don't like files?");
    }
    
  }
}
import flash.display.*;
import flash.text.*;
class TestButton extends Sprite {
  public var label:TextField;
  public function TestButton(w:Number, h:Number, labelText:String) {
    graphics.lineStyle(0.5, 0, 0, true);
    graphics.beginFill(0xa0a0a0);
    graphics.drawRoundRect(0, 0, w, h, 8);
    label = new TextField();
    addChild(label);
    label.defaultTextFormat = new TextFormat("_sans", 11, 0, true, false,
      false, null, null, "center");
    label.width = w;
    label.height = h;
    label.text = labelText;
    label.y = (h - label.textHeight)/2 - 2;
    buttonMode = true;
    mouseChildren = false;
  }
}