// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.*;
  import flash.geom.Matrix;
  import flash.net.*;
  public class ch30ex4 extends Sprite {
    protected var fileRef:FileReference;
    public function ch30ex4() {
      //CLICK THE STAGE!
      fileRef = new FileReference();
      fileRef.addEventListener(Event.SELECT, onFileSelect);
      stage.addEventListener(MouseEvent.CLICK, onChooseFile);
    }
    protected function onChooseFile(event:MouseEvent):void {
      fileRef.browse([new FileFilter("Image Files", "*.png;*.jpg;*.gif")]);
    }
    protected function onFileSelect(event:Event):void {
      fileRef.removeEventListener(Event.SELECT, onFileSelect);
      stage.removeEventListener(MouseEvent.CLICK, onChooseFile);
      
      fileRef.addEventListener(Event.COMPLETE, onFileLoad);
      fileRef.load();
    }
    protected function onFileLoad(event:Event):void {
      fileRef.removeEventListener(Event.COMPLETE, onFileLoad);
      
      //interpret the bytes into a DisplayObject
      var image:Loader = new Loader();
      image.loadBytes(fileRef.data);
      image.contentLoaderInfo.addEventListener(Event.COMPLETE, onImageParse);
    }
    protected function onImageParse(event:Event):void {
      //get the (uncompressed) bitmap that decoding the file results in
      var content:DisplayObject = LoaderInfo(event.target).content;
      var bitmapData:BitmapData = Bitmap(content).bitmapData;
      var m:Matrix = new Matrix();
      m.identity();
      m.scale(0.25, 0.25);
      graphics.clear();
      graphics.beginBitmapFill(bitmapData, m, true, true);
      graphics.drawRect(0, 0, stage.stageWidth, stage.stageHeight);
    }
  }
}