// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.events.SampleDataEvent;
  import flash.media.Sound;
  
  public class ch31ex6 extends Sprite {
    public function ch31ex6() {
      var sound:Sound = new Sound();
      sound.addEventListener(SampleDataEvent.SAMPLE_DATA, onBufferSound);
      sound.play();      
    }
    protected function onBufferSound(event:SampleDataEvent):void {
      //for every sample, from the requested position through 8k samples later
      for (var t:int = event.position; t < event.position + 8192; t++) {
        //to generate a wave with any amplitude (volume) and frequency (pitch)
        //amplitude * sin(frequency * time)
        
        //the sin of this has 1 peak every seconds--is a 1Hz wave
        var tNormalized:Number = (t / 44100) * (2 * Math.PI);

        //write middle-C (261Hz) at full (1.0) volume to the LEFT channel
        event.data.writeFloat(1.0 * Math.sin(tNormalized*261.626));
        //write G4 (392Hz) at low (0.2) volume to RIGHT channel 
        event.data.writeFloat(0.2 * Math.sin(tNormalized*391.995));
      }
    }
  }
}