// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Sprite;
  import flash.events.StatusEvent;
  import flash.media.Camera;
  import flash.media.Video;
  import flash.system.Security;
  import flash.system.SecurityPanel;
  public class ch33ex1 extends Sprite {
    protected var camera:Camera;
    protected var video:Video;
    public function ch33ex1() {
      camera = Camera.getCamera();
      if (camera) {
        camera.addEventListener(StatusEvent.STATUS, onCameraStatus);
        if (camera.muted) {
          Security.showSettings(SecurityPanel.PRIVACY);
        } else {
          attach();
        }
      }
    }
    protected function attach():void {
      video = new Video(camera.width, camera.height);
      video.attachCamera(camera);
      addChildAt(video, 0);
    }
    protected function onCameraStatus(event:StatusEvent):void {
      switch (event.code) {
        case "Camera.Muted": removeChild(video); video = null; break;
        case "Camera.Unmuted": attach(); break;
      }
    }
  }
}