// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Shape;
  import flash.display.Sprite;
  import flash.events.TimerEvent;
  import flash.geom.Matrix;
  import flash.utils.Timer;

  public class ch34ex2 extends Sprite {
    protected var s1:Shape;
    protected var s2:Shape;
    protected var moves:Array;
    protected var moveNum:int;
    protected var timer:Timer;
    
    public function ch34ex2() {
      s1 = new Shape();
      s2 = new Shape();
      s1.graphics.beginFill(0xff0000, 0.5);
      s1.graphics.drawRect(20, 20, 100, 50);
      s1.graphics.endFill();
      s2.graphics.beginFill(0x0000ff, 0.5);
      s2.graphics.drawRect(20, 20, 100, 50);
      s2.graphics.endFill();
      addChild(s1);
      addChild(s2);
      
      var m:Matrix;
      moves = new Array();

      m = new Matrix();
      m.translate(200, 0);
      moves.push(m);
      
      m = new Matrix();
      m.scale(1, 3);
      moves.push(m);
      
      m = new Matrix();
      m.rotate(Math.PI/4);
      moves.push(m);
      
     
      moveNum = 0;
      timer = new Timer(1500);
      timer.addEventListener(TimerEvent.TIMER, nextMove);
      timer.start();
    }
    protected function nextMove(event:TimerEvent):void {
      var m:Matrix;
      var i:int;
      
      i = moveNum;
      m = s1.transform.matrix;
      m.concat(moves[i]);
      s1.transform.matrix = m;
      
      i = moves.length - moveNum - 1;
      m = s2.transform.matrix;
      m.concat(moves[i]);
      s2.transform.matrix = m;
      
      if (++moveNum >= moves.length) {
        timer.stop();
      }
    }
  }
}