// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.Loader;
  import flash.display.Sprite;
  import flash.events.MouseEvent;
  import flash.geom.ColorTransform;
  import flash.net.URLRequest;
  public class ch34ex3 extends Sprite {
    protected var l:Loader;
    protected var mode:int;
    public function ch34ex3() {
      l = new Loader();
      //photo   (CC-BY) Roger Braunstein
      //source  http://www.flickr.com/photos/rogerimp/3712472723/
      l.load(new URLRequest("http://actionscriptbible.com/files/caviar.jpg"));
      addChild(l);
      l.addEventListener(MouseEvent.CLICK, clickHandler);
      l.addEventListener(MouseEvent.MOUSE_MOVE, mouseMoveHandler);
    }
    protected function mouseMoveHandler(event:MouseEvent):void {
      var value:Number = l.mouseY / l.height;
      var colorTransform:ColorTransform = l.transform.colorTransform;
      switch (mode) {
        case 0: colorTransform.redMultiplier = value; break;
        case 1: colorTransform.greenMultiplier = value; break;
        case 2: colorTransform.blueMultiplier = value; break;
        case 3: colorTransform.alphaMultiplier = value; break;
      }
      l.transform.colorTransform = colorTransform;
    }
    protected function clickHandler(event:MouseEvent):void {
      if(++mode == 4) {
        mode = 0;
      }
    }
  }
}