// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.Event;
  import flash.geom.*;
  import flash.net.URLRequest;
  import flash.system.LoaderContext;

  [SWF(frameRate="10")]
  public class ch36ex1 extends Sprite {
    protected const SIZE:Rectangle = new Rectangle(0, 0, 48, 48);
    protected var TOTALFRAMES:int;
    protected var bmp:BitmapData;
    protected var filmstrip:Loader;
    protected var frame:int = 0;
    public function ch36ex1() {
      filmstrip = new Loader();
      //Animation by Derek Yu - www.derekyu.com - used with permission
      filmstrip.load(
        new URLRequest("http://actionscriptbible.com/files/monkey.png"),
        new LoaderContext(true));
      filmstrip.contentLoaderInfo.addEventListener(Event.COMPLETE, onLoad);
      addChild(filmstrip);
      
      bmp = new BitmapData(SIZE.width, SIZE.height);
      var bitmap:Bitmap = new Bitmap(bmp);
      addChild(bitmap);
      bitmap.y = SIZE.height + 10;
    }
    protected function onLoad(event:Event):void {
      TOTALFRAMES = filmstrip.width / SIZE.width;
      addEventListener(Event.ENTER_FRAME, onEnterFrame);
    }
    protected function onEnterFrame(event:Event):void {
      frame = ++frame % TOTALFRAMES;
      
      //highlight the area we're drawing
      graphics.clear();
      graphics.lineStyle(0, 0xff0000);
      graphics.drawRect(frame*SIZE.width, 0, SIZE.width, SIZE.height);
      
      //clear the bitmap
      bmp.fillRect(bmp.rect, 0);
      //shift the filmstrip to the left to put the right frame in place
      var shiftTransform:Matrix = new Matrix();
      shiftTransform.translate(-frame * SIZE.width, 0);
      //use SIZE to clip the shifted graphic to the correct position and size
      bmp.draw(filmstrip, shiftTransform, null, null, SIZE);
    }
  }
}