// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.Event;
  import flash.media.Camera;
  import flash.media.Video;
  [SWF(width="500",height="500",frameRate="20")]
  public class ch36ex10 extends Sprite {
    protected const COLORS:Vector.<uint> = new <uint>[0xff0000, 0xff00, 0xff];
    protected const SCALE:Number = 200 / 256;
    protected var bmp:BitmapData;
    protected var video:Video;
    protected var hstR:Shape, hstG:Shape, hstB:Shape;
    protected var allHstShapes:Vector.<Shape>;
    public function ch36ex10() {
      bmp = new BitmapData(stage.stageWidth, stage.stageHeight);
      video = new Video(stage.stageWidth, stage.stageHeight);
      video.attachCamera(Camera.getCamera());
      addChild(video);
      stage.addEventListener(Event.ENTER_FRAME, onEnterFrame);
      var hstbox:Sprite = new Sprite();
      addChild(hstbox);
      hstbox.x = stage.stageWidth - 270 - 10;
      hstbox.y = 10;
      hstbox.graphics.lineStyle(0, 0xffffff);
      hstbox.graphics.beginFill(0, 0.5);
      hstbox.graphics.drawRect(0, 0, 270, 150);
      hstR = new Shape(); hstG = new Shape(); hstB = new Shape();
      allHstShapes = new <Shape>[hstR, hstG, hstB];
      for each (var hstShape:Shape in allHstShapes) {
        hstbox.addChild(hstShape);
        hstShape.y = hstbox.height - 10;
        hstShape.blendMode = BlendMode.ADD;
        hstShape.rotationY = 35;
        hstShape.scaleY = -1;
      }
      hstR.x = 10; hstG.x = 30; hstB.x = 50;
    }
    protected function onEnterFrame(event:Event):void {
      bmp.draw(video);
      var allHstData:Vector.<Vector.<Number>> = bmp.histogram(bmp.rect);
      var PIXELCOUNT:int = bmp.width*bmp.height;
      for (var i:int = 0; i < allHstShapes.length; i++) {
        var hstData:Vector.<Number> = allHstData[i];
        var g:Graphics = allHstShapes[i].graphics;
        g.clear();
        g.beginFill(COLORS[i]);
        for (var x:int = 0; x < hstData.length; x++) {
          g.drawRect(x*SCALE, 0, SCALE, hstData[x]/PIXELCOUNT * 1500*SCALE);
        }
      }
    }
  }
}