// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.MouseEvent;
  import flash.geom.Point;

  [SWF(backgroundColor="#000000")]
  public class ch36ex4 extends Sprite {
    protected var center:Point;
    protected var sourceBmp:BitmapData;
    protected var destBmp:BitmapData;
    protected var splitChannelsBitmap:Bitmap;
    public function ch36ex4() {
      //draw a white circle in the center
      center = new Point(stage.stageWidth/2, stage.stageHeight/2);
      var source:Shape = new Shape();
      source.x = center.x; source.y = center.y;
      addChild(source);
      source.graphics.beginFill(0xffffff, 1);
      source.graphics.drawCircle(0, 0, 100);
      
      //capture a bitmap of the white circle in sourceBmp
      sourceBmp = new BitmapData(stage.stageWidth, stage.stageHeight, false, 0);
      destBmp = sourceBmp.clone();
      sourceBmp.draw(stage);
      
      //create a holder for destBmp
      splitChannelsBitmap = new Bitmap(destBmp);
      addChild(splitChannelsBitmap);

      stage.addEventListener(MouseEvent.MOUSE_MOVE, onMouseMove);
    }
    protected function onMouseMove(event:MouseEvent):void {
      //hold mouse button to show source graphic
      splitChannelsBitmap.visible = !event.buttonDown; 
      var dist:Number = Point.distance(new Point(stage.mouseX, stage.mouseY),
        center) / 2;
      //copy the white circle, offseting RGB channels based on mouse location
      destBmp.copyChannel(sourceBmp, sourceBmp.rect, new Point(0, -dist),
        BitmapDataChannel.RED, BitmapDataChannel.RED);
      destBmp.copyChannel(sourceBmp, sourceBmp.rect, new Point(-dist, dist),
        BitmapDataChannel.GREEN, BitmapDataChannel.GREEN);
      destBmp.copyChannel(sourceBmp, sourceBmp.rect, new Point(dist, dist),
        BitmapDataChannel.BLUE, BitmapDataChannel.BLUE);
      event.updateAfterEvent();
    }
  }
}