// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.*;
  import flash.geom.*;
  [SWF(backgroundColor="#000000",frameRate="60")]
  public class ch36ex9 extends Sprite {
    protected const MAXSPEED:Number = 8;
    protected var ball:Shape;
    protected var holder:Sprite;
    protected var bmp:BitmapData;
    protected var velocity:Point
    public function ch36ex9() {
      bmp = new BitmapData(stage.stageWidth, stage.stageHeight);
      var bitmap:Bitmap = new Bitmap(bmp);
      addChild(bitmap);
      holder = new Sprite();
      addChild(holder);
      ball = new Shape();
      ball.graphics.lineStyle(0, 0xff0000);
      ball.graphics.beginFill(0xffffff, 0.1);
      ball.graphics.drawCircle(0, 0, 30);
      holder.addChild(ball);
      stage.addEventListener(Event.ENTER_FRAME, onEnterFrame);
      stage.addEventListener(MouseEvent.CLICK, onMouseClick);
      velocity = new Point(1, 1);
    }
    protected function onEnterFrame(event:Event):void {
      ball.x += velocity.x;
      ball.y += velocity.y;
      ball.rotation += velocity.length / 5;
      if (ball.x >= bmp.width || ball.x <= 0) velocity.x *= -1;
      if (ball.y >= bmp.height || ball.y <= 0) velocity.y *= -1;
      bmp.colorTransform(bmp.rect, new ColorTransform(1, 1, 1, 0.9));
      bmp.draw(holder);
    }
    protected function onMouseClick(event:MouseEvent):void {
      ball.x = stage.mouseX;
      ball.y = stage.mouseY;
      velocity.x = Math.random() * MAXSPEED * 2 - MAXSPEED;
      velocity.y = Math.random() * MAXSPEED * 2 - MAXSPEED;
    }
  }
}