// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import flash.display.*;
  import flash.events.Event;
  import flash.text.*;
  import flash.utils.getTimer;

  public class ch39ex3 extends Sprite {
    protected const SPEED:Number = 50 / 1000;
    //50 pixels per second * 1 sec / 1000 ms = 50/1000 pixels per millisecond
    protected var ball:DisplayObject;
    protected var tf:TextField;
    protected var lastTime:int;
    public function ch39ex3() {
      ball = new Ball();
      ball.y = stage.stageHeight/2;
      addChild(ball);
      tf = new TextField(); tf.width = 0; tf.height = 14; tf.x = tf.y = 5;
      tf.autoSize = TextFieldAutoSize.LEFT;
      tf.backgroundColor = 0; tf.background = true;
      tf.defaultTextFormat = new TextFormat("_typewriter", 11, 0xffffff);
      addChild(tf);
      addEventListener(Event.ENTER_FRAME, onEnterFrame);
      lastTime = getTimer();
    }
    protected function onEnterFrame(event:Event):void {
      //mess things up by changing the framerate randomly
      stage.frameRate = Math.random() * 45 + 1;
      
      var time:int = getTimer();
      var dt:Number = time - lastTime;
      ball.x += SPEED * dt;
      lastTime = time;

      tf.text = stage.frameRate.toFixed() + " fps";
      if (ball.x > stage.stageWidth) ball.x = 0;
    }
  }
}
import flash.display.Shape;
class Ball extends Shape {
  public function Ball(color:uint = 0xff0000, size:Number = 50) {
    graphics.beginFill(color);
    graphics.drawCircle(0, 0, size);
  }
}