// The following code is example code from 
// "ActionScript 3.0 Bible, 2nd Edition" by Roger Braunstein
// Find all of the source code on the companion website
// http://actionscriptbible.com/
//
// Copyright (c) 2010 by Wiley Publishing, Inc., Indianapolis, Indiana
//
// Permission is hereby granted, free of charge, to any person
// obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without
// restriction, including without limitation the rights to use,
// copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following
// conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
// OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
// HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
// WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
// OTHER DEALINGS IN THE SOFTWARE.

package {
  import com.actionscriptbible.Example;
  
  public class ch4ex7 extends Example {
    public function ch4ex7() {
      var array:Array = ["hello", "world"];
      var obj:Object;
      //Pull a value off the front of the array, set obj to that value,
      //and check if obj converts to true or false. Stop the loop when
      //the value converts to false. Null is returned by shift() when
      //there are no more values in the array. Null converts to false. 
      while (obj = array.shift()) {
        trace(obj);
      }
      //hello
      //world
      
      var str:String = "";
      //Set a default string if the string doesn’t exist or is empty.
      //Both empty strings and null values convert to false.
      //Negating false gives you true so the conditional runs if
      //the string is empty, giving it a default value instead.
      if (!str) str = "Default";
      trace(str); //Default
      
      for (var i:int = 1; i < 4; i++)
      {
        //Trace out the number (i) and whether it is odd or even.
        //i % 2 is the remainder when you divide it by two, always
        //a whole number. Any number converts to true, except 0
        //which converts to false. So when the remainder after
        //dividing by two is zero, the conditional is false.
        trace(i, (i % 2)? "odd" : "even");
      }
      //1 odd
      //2 even
      //3 odd
    }
  }
}